package usherbrooke.ift630;

import java.util.ArrayList;

public class Bus extends Thread {
	private ArrayList<Passenger>	passengers;
	private ArrayList<Stop>			stops;
	private String					name;
	private int						id;
	private int						maxCapacity;
	private int						currentCapacity;
	private int						timeBetweenStops;
	private Stop					currentStop;

	private int timeBetweenStops() {
		return (int) (Math.random() * timeBetweenStops * timeBetweenStops);
	}

	private Stop goToNextStop() {
		currentStop = stops.remove(0);
		try {
			Thread.sleep(timeBetweenStops() * 1000);
		} catch (InterruptedException e) {
			System.out.println(e.getMessage());
		}
		return currentStop;
	}

	// TODO ??
	private ArrayList<Passenger> getNextStopPassengers() {
		ArrayList<Passenger> res = new ArrayList<Passenger>();

		for (Passenger p : passengers) {
			Stop next = stops.get(1);
			next.getPassengerByDest(stops);
		}

		return res;
	}

	@Override
	public void run() {
		while (currentStop != null) {
			embarkPassengers();
			disembarkPassengers();

			currentStop = goToNextStop();
		}
	}

	Bus(ArrayList<Stop> s, int id, int time, int maxCapacity) {
		this.timeBetweenStops = time;
		this.name =				"Bus n°" + id;
		this.id =				id;
		this.passengers =		new ArrayList<Passenger>();
		this.stops =			s;
		this.currentStop =		stops.get(0);
		this.currentCapacity =	0;
		this.maxCapacity =		maxCapacity;
	}

	public synchronized void disembarkPassengers() {
		for (Passenger p : passengers) {
			Logger.getInstance().print(id, "[BUS] " + p.getName() + " got out of " + name);

			if (p.getDest() == currentStop) {
				p.disembark();
				currentCapacity--;
			}
		}
	}

	public synchronized void embarkPassengers() {
		try {
			ArrayList<Passenger> list = currentStop.getPassengerByDest(stops);
			Logger.getInstance().print(id, "[BUS] hop into " + name + "!");
			if (currentCapacity >= maxCapacity)
				throw new OverCapacityException("Over bus capacity.");
			for (Passenger p : list) {
				passengers.add(p);
				currentStop.removePassenger(p);
				currentCapacity++;

				Logger.getInstance().print(id,
						"[BUS] " + p.getName() + " embarked in " + name + " at " + currentStop.getName());
			}
		} catch (IndexOutOfBoundsException | OverCapacityException e) {
			Logger.getInstance().print(id, "ERROR " + e.getMessage());
		}
	}

	public void printDetails(int indent) {
		Logger.getInstance().print(id, "\t".repeat(indent) + "---".repeat(3) + " Bus details " + "---".repeat(3));
		Logger.getInstance().print(id, "\t".repeat(indent) + name);
		Logger.getInstance().print(id, "\t".repeat(indent) + "time between stops: " + timeBetweenStops);
		Logger.getInstance().print(id, "\t".repeat(indent) + "max capacity: " + maxCapacity);
		Logger.getInstance().print(id, "\t".repeat(indent) + "current stop: " + currentStop.getName());
		Logger.getInstance().print(id, "\t".repeat(indent) + "stops: " );


		for (Stop s : stops) {
			s.printDetails(indent + 1);
		}
	}

	public void printDetails() {
		printDetails(0);
	}

}
